#ifndef EFL_GENERATED_ECORE_AUDIO_HH
#define EFL_GENERATED_ECORE_AUDIO_HH

#include <Eo.h>
#include <Eo.hh>

extern "C"
{
#include "ecore_audio.eo.h"
}


struct ecore_audio
      : efl::eo::base
{
   /// @brief Eo Constructor.
   ///
   /// Constructs the object from an Eo* pointer stealing its ownership.
   ///
   /// @param eo The Eo object pointer.
   ///
   explicit ecore_audio(Eo* eo)
      : efl::eo::base(eo)
   {}

   ecore_audio(efl::eo::parent_type _p = (efl::eo::parent = nullptr))
      : ecore_audio(_c0(_p))
   {}

   /// @brief Copy Constructor.
   ///
   ecore_audio(ecore_audio const& other)
      : efl::eo::base(eo_ref(other._eo_ptr()))
   {}

   ~ecore_audio() {}

   /// @brief Set the virtual IO functions
   ///
   /// @since 1.8
   ///
   /// @param vio 
   /// @param data 
   /// @param free_func 
   ///
   void vio_set(Ecore_Audio_Vio * vio, void * data, eo_key_data_free_func free_func) const
   {
      eo_do(_eo_ptr(), ::ecore_audio_obj_vio_set(vio, data, free_func));
   }

   /// @brief Get the name of the object
   ///
   /// @since 1.8
   ///
   /// @param name 
   ///
   const char * name_get() const
   {
      const char * _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::ecore_audio_obj_name_get());
      return _tmp_ret;
   }

   /// @brief Set the name of the object
   ///
   /// @since 1.8
   ///
   /// @param name 
   ///
   void name_set(const char * name) const
   {
      eo_do(_eo_ptr(), ::ecore_audio_obj_name_set(name));
   }

   /// @brief Get the pause state of the object
   ///
   /// @since 1.8
   ///
   /// @param paused 
   ///
   Eina_Bool paused_get() const
   {
      Eina_Bool _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::ecore_audio_obj_paused_get());
      return _tmp_ret;
   }

   /// @brief Set the pause state of the object
   ///
   /// @since 1.8
   ///
   /// @param paused 
   ///
   void paused_set(Eina_Bool paused) const
   {
      eo_do(_eo_ptr(), ::ecore_audio_obj_paused_set(paused));
   }

   /// @brief Get the volume of the object
   ///
   /// @since 1.8
   ///
   /// @param volume 
   ///
   double volume_get() const
   {
      double _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::ecore_audio_obj_volume_get());
      return _tmp_ret;
   }

   /// @brief Set the volume of the object
   ///
   /// @since 1.8
   ///
   /// @param volume 
   ///
   void volume_set(double volume) const
   {
      eo_do(_eo_ptr(), ::ecore_audio_obj_volume_set(volume));
   }

   /// @brief Get the source of the object
   ///
   /// @since 1.8
   ///
   /// @param source 
   ///
   const char * source_get() const
   {
      const char * _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::ecore_audio_obj_source_get());
      return _tmp_ret;
   }

   /// @brief Set the source of the object
   ///
   /// What sources are supported depends on the actual object. For example,
   /// the libsndfile class accepts WAV, OGG, FLAC files as source.
   ///
   /// @since 1.8
   ///
   /// @param source 
   ///
   Eina_Bool source_set(const char * source) const
   {
      Eina_Bool _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::ecore_audio_obj_source_set(source));
      return _tmp_ret;
   }

   /// @brief Get the format of the object
   ///
   /// After setting the source if the format was ECORE_AUDIO_FORMAT_AUTO this
   /// function will now return the actual format.
   ///
   /// @since 1.8
   ///
   /// @param format 
   ///
   Ecore_Audio_Format format_get() const
   {
      Ecore_Audio_Format _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::ecore_audio_obj_format_get());
      return _tmp_ret;
   }

   /// @brief Set the format of the object
   ///
   /// What formats are supported depends on the actual object. Default is
   /// ECORE_AUDIO_FORMAT_AUTO
   ///
   /// @since 1.8
   ///
   /// @param format 
   ///
   Eina_Bool format_set(Ecore_Audio_Format format) const
   {
      Eina_Bool _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::ecore_audio_obj_format_set(format));
      return _tmp_ret;
   }

   static Eo_Class const* _eo_class()
   {
      return(ECORE_AUDIO_OBJ_CLASS);
   }

private:
   static Eo* _c0(efl::eo::parent_type _p)
   {
      return eo_add_custom(ECORE_AUDIO_OBJ_CLASS, _p._eo_raw, eo_constructor());
   }

};
template <typename T>
void ecore_audio_vio_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Ecore_Audio_Vio * vio, void * data, eo_key_data_free_func free_func)
{
   static_cast<T*>(self->this_)->vio_set(vio, data, free_func);
}

template <typename T>
const char * ecore_audio_name_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   return static_cast<T*>(self->this_)->name_get();
}

template <typename T>
void ecore_audio_name_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, const char * name)
{
   static_cast<T*>(self->this_)->name_set(name);
}

template <typename T>
Eina_Bool ecore_audio_paused_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   return static_cast<T*>(self->this_)->paused_get();
}

template <typename T>
void ecore_audio_paused_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Eina_Bool paused)
{
   static_cast<T*>(self->this_)->paused_set(paused);
}

template <typename T>
double ecore_audio_volume_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   return static_cast<T*>(self->this_)->volume_get();
}

template <typename T>
void ecore_audio_volume_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, double volume)
{
   static_cast<T*>(self->this_)->volume_set(volume);
}

template <typename T>
const char * ecore_audio_source_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   return static_cast<T*>(self->this_)->source_get();
}

template <typename T>
Eina_Bool ecore_audio_source_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, const char * source)
{
   return static_cast<T*>(self->this_)->source_set(source);
}

template <typename T>
Ecore_Audio_Format ecore_audio_format_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   return static_cast<T*>(self->this_)->format_get();
}

template <typename T>
Eina_Bool ecore_audio_format_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Ecore_Audio_Format format)
{
   return static_cast<T*>(self->this_)->format_set(format);
}

namespace efl { namespace eo { namespace detail {

template<>
struct operations< ::ecore_audio >
{
   template <typename T>
   struct type
   {
      virtual void vio_set(Ecore_Audio_Vio * vio, void * data, eo_key_data_free_func free_func)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr()
            , static_cast<T*>(this)->_eo_class()
            , ::ecore_audio_obj_vio_set(vio, data, free_func));
      }

      virtual const char * name_get()
      {
         const char * _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr()
            , static_cast<T*>(this)->_eo_class()
            , _tmp_ret = ::ecore_audio_obj_name_get());
         return _tmp_ret;
      }

      virtual void name_set(const char * name)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr()
            , static_cast<T*>(this)->_eo_class()
            , ::ecore_audio_obj_name_set(name));
      }

      virtual Eina_Bool paused_get()
      {
         Eina_Bool _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr()
            , static_cast<T*>(this)->_eo_class()
            , _tmp_ret = ::ecore_audio_obj_paused_get());
         return _tmp_ret;
      }

      virtual void paused_set(Eina_Bool paused)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr()
            , static_cast<T*>(this)->_eo_class()
            , ::ecore_audio_obj_paused_set(paused));
      }

      virtual double volume_get()
      {
         double _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr()
            , static_cast<T*>(this)->_eo_class()
            , _tmp_ret = ::ecore_audio_obj_volume_get());
         return _tmp_ret;
      }

      virtual void volume_set(double volume)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr()
            , static_cast<T*>(this)->_eo_class()
            , ::ecore_audio_obj_volume_set(volume));
      }

      virtual const char * source_get()
      {
         const char * _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr()
            , static_cast<T*>(this)->_eo_class()
            , _tmp_ret = ::ecore_audio_obj_source_get());
         return _tmp_ret;
      }

      virtual Eina_Bool source_set(const char * source)
      {
         Eina_Bool _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr()
            , static_cast<T*>(this)->_eo_class()
            , _tmp_ret = ::ecore_audio_obj_source_set(source));
         return _tmp_ret;
      }

      virtual Ecore_Audio_Format format_get()
      {
         Ecore_Audio_Format _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr()
            , static_cast<T*>(this)->_eo_class()
            , _tmp_ret = ::ecore_audio_obj_format_get());
         return _tmp_ret;
      }

      virtual Eina_Bool format_set(Ecore_Audio_Format format)
      {
         Eina_Bool _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr()
            , static_cast<T*>(this)->_eo_class()
            , _tmp_ret = ::ecore_audio_obj_format_set(format));
         return _tmp_ret;
      }

   };
};


template<>
struct operation_description_class_size< ::ecore_audio >
{
   static const int value = 11;
};

template <typename T>
int initialize_operation_description(efl::eo::detail::tag<::ecore_audio>
                                 , Eo_Op_Description* ops)
{
   (void)ops;
   ops[0].func = reinterpret_cast<void*>(& ::ecore_audio_vio_set_wrapper<T>);
   ops[0].api_func = reinterpret_cast<void*>(& ::ecore_audio_obj_vio_set);
   ops[0].op = EO_OP_OVERRIDE;
   ops[0].op_type = EO_OP_TYPE_REGULAR;
   ops[0].doc = NULL;

   ops[1].func = reinterpret_cast<void*>(& ::ecore_audio_name_get_wrapper<T>);
   ops[1].api_func = reinterpret_cast<void*>(& ::ecore_audio_obj_name_get);
   ops[1].op = EO_OP_OVERRIDE;
   ops[1].op_type = EO_OP_TYPE_REGULAR;
   ops[1].doc = NULL;

   ops[2].func = reinterpret_cast<void*>(& ::ecore_audio_name_set_wrapper<T>);
   ops[2].api_func = reinterpret_cast<void*>(& ::ecore_audio_obj_name_set);
   ops[2].op = EO_OP_OVERRIDE;
   ops[2].op_type = EO_OP_TYPE_REGULAR;
   ops[2].doc = NULL;

   ops[3].func = reinterpret_cast<void*>(& ::ecore_audio_paused_get_wrapper<T>);
   ops[3].api_func = reinterpret_cast<void*>(& ::ecore_audio_obj_paused_get);
   ops[3].op = EO_OP_OVERRIDE;
   ops[3].op_type = EO_OP_TYPE_REGULAR;
   ops[3].doc = NULL;

   ops[4].func = reinterpret_cast<void*>(& ::ecore_audio_paused_set_wrapper<T>);
   ops[4].api_func = reinterpret_cast<void*>(& ::ecore_audio_obj_paused_set);
   ops[4].op = EO_OP_OVERRIDE;
   ops[4].op_type = EO_OP_TYPE_REGULAR;
   ops[4].doc = NULL;

   ops[5].func = reinterpret_cast<void*>(& ::ecore_audio_volume_get_wrapper<T>);
   ops[5].api_func = reinterpret_cast<void*>(& ::ecore_audio_obj_volume_get);
   ops[5].op = EO_OP_OVERRIDE;
   ops[5].op_type = EO_OP_TYPE_REGULAR;
   ops[5].doc = NULL;

   ops[6].func = reinterpret_cast<void*>(& ::ecore_audio_volume_set_wrapper<T>);
   ops[6].api_func = reinterpret_cast<void*>(& ::ecore_audio_obj_volume_set);
   ops[6].op = EO_OP_OVERRIDE;
   ops[6].op_type = EO_OP_TYPE_REGULAR;
   ops[6].doc = NULL;

   ops[7].func = reinterpret_cast<void*>(& ::ecore_audio_source_get_wrapper<T>);
   ops[7].api_func = reinterpret_cast<void*>(& ::ecore_audio_obj_source_get);
   ops[7].op = EO_OP_OVERRIDE;
   ops[7].op_type = EO_OP_TYPE_REGULAR;
   ops[7].doc = NULL;

   ops[8].func = reinterpret_cast<void*>(& ::ecore_audio_source_set_wrapper<T>);
   ops[8].api_func = reinterpret_cast<void*>(& ::ecore_audio_obj_source_set);
   ops[8].op = EO_OP_OVERRIDE;
   ops[8].op_type = EO_OP_TYPE_REGULAR;
   ops[8].doc = NULL;

   ops[9].func = reinterpret_cast<void*>(& ::ecore_audio_format_get_wrapper<T>);
   ops[9].api_func = reinterpret_cast<void*>(& ::ecore_audio_obj_format_get);
   ops[9].op = EO_OP_OVERRIDE;
   ops[9].op_type = EO_OP_TYPE_REGULAR;
   ops[9].doc = NULL;

   ops[10].func = reinterpret_cast<void*>(& ::ecore_audio_format_set_wrapper<T>);
   ops[10].api_func = reinterpret_cast<void*>(& ::ecore_audio_obj_format_set);
   ops[10].op = EO_OP_OVERRIDE;
   ops[10].op_type = EO_OP_TYPE_REGULAR;
   ops[10].doc = NULL;

   return 0;
}
inline void
call_constructor(tag< ::ecore_audio >
               , Eo* eo, Eo_Class const* cls EINA_UNUSED,
               args_class<::ecore_audio, ::std::tuple<> > const& args)
{
   (void)args;
   eo_do_super(eo, cls, ::eo_constructor());
}

template<>
struct extension_inheritance< ::ecore_audio>
{
   template <typename T>
   struct type
   {
      operator ::ecore_audio() const
      {
         return ::ecore_audio(eo_ref(static_cast<T const*>(this)->_eo_ptr()));
      }

      void vio_set(Ecore_Audio_Vio * vio, void * data, eo_key_data_free_func free_func)
      {
         eo_do(static_cast<T*>(this)->_eo_ptr(), ::ecore_audio_obj_vio_set(vio, data, free_func));
      }

      const char * name_get()
      {
         const char * _tmp_ret = {};
         eo_do(static_cast<T*>(this)->_eo_ptr(), _tmp_ret = ::ecore_audio_obj_name_get());
         return _tmp_ret;
      }

      void name_set(const char * name)
      {
         eo_do(static_cast<T*>(this)->_eo_ptr(), ::ecore_audio_obj_name_set(name));
      }

      Eina_Bool paused_get()
      {
         Eina_Bool _tmp_ret = {};
         eo_do(static_cast<T*>(this)->_eo_ptr(), _tmp_ret = ::ecore_audio_obj_paused_get());
         return _tmp_ret;
      }

      void paused_set(Eina_Bool paused)
      {
         eo_do(static_cast<T*>(this)->_eo_ptr(), ::ecore_audio_obj_paused_set(paused));
      }

      double volume_get()
      {
         double _tmp_ret = {};
         eo_do(static_cast<T*>(this)->_eo_ptr(), _tmp_ret = ::ecore_audio_obj_volume_get());
         return _tmp_ret;
      }

      void volume_set(double volume)
      {
         eo_do(static_cast<T*>(this)->_eo_ptr(), ::ecore_audio_obj_volume_set(volume));
      }

      const char * source_get()
      {
         const char * _tmp_ret = {};
         eo_do(static_cast<T*>(this)->_eo_ptr(), _tmp_ret = ::ecore_audio_obj_source_get());
         return _tmp_ret;
      }

      Eina_Bool source_set(const char * source)
      {
         Eina_Bool _tmp_ret = {};
         eo_do(static_cast<T*>(this)->_eo_ptr(), _tmp_ret = ::ecore_audio_obj_source_set(source));
         return _tmp_ret;
      }

      Ecore_Audio_Format format_get()
      {
         Ecore_Audio_Format _tmp_ret = {};
         eo_do(static_cast<T*>(this)->_eo_ptr(), _tmp_ret = ::ecore_audio_obj_format_get());
         return _tmp_ret;
      }

      Eina_Bool format_set(Ecore_Audio_Format format)
      {
         Eina_Bool _tmp_ret = {};
         eo_do(static_cast<T*>(this)->_eo_ptr(), _tmp_ret = ::ecore_audio_obj_format_set(format));
         return _tmp_ret;
      }

   };
};

inline Eo_Class const* get_eo_class(tag<::ecore_audio>)
{
   return (ECORE_AUDIO_OBJ_CLASS);
}

} } }
#endif // EFL_GENERATED_ECORE_AUDIO_HH

